static  LAST_REC, ONE_PART, METER_LINE,REC_NO, INVIDEO, Active := .f.

*!*****************************************************************************
*!
*!       Function: PROGRESS()
*!
*!*****************************************************************************
function PROGRESS()

local incolor := setcolor()

if Active
   
   REC_NO ++
   
   setcolor("gb+/b")
   
   if LAST_REC > 50
      if REC_NO%ONE_PART == 0 .or. REC_NO == LAST_REC
         @ METER_LINE, 15 +(( REC_NO / LAST_REC ) * 49 ) say ''
      endif
   else
      if LAST_REC > 2
         @ METER_LINE, 15 say replicate('',min(( REC_NO / LAST_REC ) * 50,50))
      else
         @ METER_LINE, 15 say replicate('',50)
      endif
   endif
   
   setcolor(incolor)
            
endif
         
return NIL
         
         
*!*****************************************************************************
*!
*!       Function: INIT_PROGRESS()
*!
*!*****************************************************************************
function INIT_PROGRESS(LINE_NO,TOT_COUNT)

local INCOLOR := setcolor()

METER_LINE := LINE_NO

INVIDEO := Savescreen(LINE_NO-2,13,LINE_NO+1,66)

SETCOLOR("g+/b")
dispbox(LINE_NO-2,13,LINE_NO+1,66)
SETCOLOR("gr+/b")
@ LINE_NO-1,14 say ' 0 . . . . . . . . . . .50. . . . . . . . . . . 100 '
@ LINE_NO,14 say space(52)
SETCOLOR("bg/b")
@ METER_LINE, 15 say ''
   
REC_NO := -1
LAST_REC := iif(TOT_COUNT = NIL,lastrec(),TOT_COUNT)
ONE_PART := int(LAST_REC/48)

setcolor(INCOLOR)

Active := .t.

return NIL
   
*!*****************************************************************************
*!
*!       Function: KILL_PROGRESS()
*!
*!*****************************************************************************
function KILL_PROGRESS()

restscreen(METER_LINE-2,13,METER_LINE+1,66,INVIDEO)

Active := .f.

return NIL

*: EOF: PROGRESS.PRG
