
#include "slvrclip.ch"

function HITCOM(parm1,PORT,BAUD,FILENAME,LINELEN,RECORDCOUNT)

clear screen

if valtype(parm1) != 'C'  // is parm1 character?
  ?
  ? 'Usage:'
  ?
  ? 'HITCOM RECEIVE 1 19200'
  ?
  ? 'or'
  ?
  ? 'HITCOM TRANSMIT 1 19200 FILENAME LINELEN RECORDCOUNT'
  ?
  ?
  quit
endif

if port == NIL
  port := 0
else
  port := val(port)-1
endif

if baud == NIL
  baud := 19200
else
  baud := val(baud)
endif

if valtype(LINELEN) == 'C'
  LINELEN := VAL(LINELEN)
ENDIF

if valtype(RECORDCOUNT) == 'C'
  RECORDCOUNT := VAL(RECORDCOUNT)
ENDIF

set cursor (.f.)

do case
case upper(parm1) == 'RECEIVE'
  SWOPENCOM(PORT,4096,4096)
  SWSETUART(PORT,BAUD,SWPARITYNONE,8,1)
  if pit_recv(port)
    stat('Successful Receive')
  else
    stat("Receive operation failed")
  endif
  setpos(22,0)
  swclosecom(PORT,0)
case upper(parm1) == 'TRANSMIT' .AND. PCOUNT() == 6
  SWOPENCOM(PORT,4096,4096)
  SWSETUART(PORT,BAUD,SWPARITYNONE,8,1)
  IF PIT_TRAN(PORT,FILENAME,LINELEN,RECORDCOUNT) == .T.
    stat('Successful Transmission')
  else
    stat("Transmit operation failed")
  endif
  setpos(22,0)
  swclosecom(PORT,0)
OTHERWISE
  ?
  ? 'Usage:'
  ?
  ? 'HITCOM RECEIVE 1 19200'
  ?
  ? 'or'
  ?
  ? 'HITCOM TRANSMIT 1 19200 FILENAME LINELEN RECORDCOUNT'
  ?
  ?
ENDCASE

set cursor (.t.)

return NIL
